//+------------------------------------------------------------------+
//|                                       DSWS_OnClick_Indicator.mq4 |
//|                                            Copyright 2015, Dadas |
//|                                   http://www.fx-nvatc.comeze.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Dadas"
#property link      "http://www.fx-nvatc.comeze.com"
#property indicator_chart_window

extern bool  Freeze_DSWS = false;
extern int   Master_Tf = 0;
extern bool  HL_Mode = false;

extern color Bull_Trend_Color=DarkGreen;
extern color Entry_Zone_Buy_Color=DarkSlateGray;  
extern color Bear_Trend_Color=Maroon;
extern color Entry_Zone_Sell_Color=DarkSlateGray;  
extern color Info_Color = Snow;
extern bool  PIVOT_Fib50_Mode = true;
extern color Pivot_Color = Gold;
extern color Sup_Res_Bull_Color = LimeGreen;
extern color Sup_Res_Bear_Color = Red;
extern bool  Hide_Zones = true;
extern bool  Hide_Pivot = false;
extern bool  Hide_Sup_Res_Lines = false;
extern bool  Show_Close_Lines = false;
extern bool  PTECZ_Mode = true;
extern color Close_Line_Color = Magenta;

extern bool  Plot_Candle_Fib  = false;

double po,pc,pl,ph,p382,p618,pt,pt2,ptrev;
datetime t1,t2;
color Trend_Color,Reversal_Color,Entry_Zone_Color,CL_Color,OL_Color,Wick_Color;
int Shift;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
   for(Shift=1; Shift<9999; Shift++) 
     {
      Wick_Color=ChartGetInteger(0,CHART_COLOR_BACKGROUND,0);
      ObjectCreate(0,"Wick"+Shift,OBJ_TREND,0,0,0,0,0);
      ObjectSet("Wick"+Shift,OBJPROP_TIME1,Time[Shift]);
      ObjectSet("Wick"+Shift,OBJPROP_PRICE1,High[Shift]);
      ObjectSet("Wick"+Shift,OBJPROP_TIME2,Time[Shift]);
      ObjectSet("Wick"+Shift,OBJPROP_PRICE2,Low[Shift]);
      ObjectSet("Wick"+Shift,OBJPROP_COLOR,Wick_Color);
      ObjectSet("Wick"+Shift,OBJPROP_STYLE,0);
      ObjectSet("Wick"+Shift,OBJPROP_WIDTH,0);
      ObjectSet("Wick"+Shift,OBJPROP_RAY,false);
      ObjectSet("Wick"+Shift,OBJPROP_BACK,true);
      ObjectSet("Wick"+Shift,OBJPROP_SELECTABLE,false);
      ObjectSet("Wick"+Shift,OBJPROP_HIDDEN,true);
      ObjectSet("Wick"+Shift,OBJPROP_ZORDER,5);
     }
  }
  
void OnDeinit(const int reason)
  {
   for(Shift=0; Shift<Bars; Shift++) 
     {
      ObjectDelete(0,"Wick"+Shift);
      ObjectDelete("Fib_Line"+Shift);
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  if(IsNewBar())
   {
      ObjectCreate(0,"Wick0",OBJ_TREND,0,0,0,0,0);
      ObjectSet("Wick0",OBJPROP_TIME1,Time[Shift]);
      ObjectSet("Wick0",OBJPROP_PRICE1,High[Shift]);
      ObjectSet("Wick0",OBJPROP_TIME2,Time[Shift]);
      ObjectSet("Wick0",OBJPROP_PRICE2,Low[Shift]);
      ObjectSet("Wick0",OBJPROP_COLOR,Wick_Color);
      ObjectSet("Wick0",OBJPROP_STYLE,0);
      ObjectSet("Wick0",OBJPROP_WIDTH,2);
      ObjectSet("Wick0",OBJPROP_RAY,false);
      ObjectSet("Wick0",OBJPROP_BACK,true);
      ObjectSet("Wick0",OBJPROP_SELECTABLE,false);
      ObjectSet("Wick0",OBJPROP_HIDDEN,true);
      ObjectSet("Wick0",OBJPROP_ZORDER,5);
    
   for(Shift=1; Shift<9999; Shift++) 
     {
      ObjectSet("Wick"+Shift,OBJPROP_TIME1,Time[Shift]);
      ObjectSet("Wick"+Shift,OBJPROP_PRICE1,High[Shift]);
      ObjectSet("Wick"+Shift,OBJPROP_TIME2,Time[Shift]);
      ObjectSet("Wick"+Shift,OBJPROP_PRICE2,Low[Shift]);
                   if(Plot_Candle_Fib)
                    {
                   color cFibLine_Color;
                   double Fib_Price;
                   if(Open[Shift]<Close[Shift])
                    {
                    cFibLine_Color=ChartGetInteger(0,CHART_COLOR_CHART_UP,0);
                    Fib_Price=High[Shift]-(High[Shift]-Low[Shift])*0.618;
                    }
                   if(Open[Shift]>Close[Shift])
                    {
                    cFibLine_Color=ChartGetInteger(0,CHART_COLOR_CHART_DOWN,0);
                    Fib_Price=Low[Shift]+(High[Shift]-Low[Shift])*0.618;
                    }
                    
                   ObjectCreate("Fib_Line"+Shift, OBJ_TREND, 0, 0,0, 0,0);
                   ObjectSet("Fib_Line"+Shift, OBJPROP_COLOR, cFibLine_Color);
                   ObjectSet("Fib_Line"+Shift, OBJPROP_PRICE1, Fib_Price);      
                   ObjectSet("Fib_Line"+Shift, OBJPROP_PRICE2, Fib_Price);      
                   ObjectSet("Fib_Line"+Shift, OBJPROP_TIME1, Time[Shift]);      
                   ObjectSet("Fib_Line"+Shift, OBJPROP_TIME2, Time[Shift]+Period()*60*2); //     
                   ObjectSet("Fib_Line"+Shift, OBJPROP_STYLE, 0);      
                   ObjectSet("Fib_Line"+Shift, OBJPROP_WIDTH, 1);      
                   ObjectSet("Fib_Line"+Shift, OBJPROP_RAY, false);
                   ObjectSet("Fib_Line"+Shift, OBJPROP_BACK, false);             
                   ObjectSet("Fib_Line"+Shift, OBJPROP_SELECTABLE, false);
                   ObjectSet("Fib_Line"+Shift, OBJPROP_HIDDEN, true);
                   ObjectSet("Fib_Line"+Shift, OBJPROP_ZORDER, 0);
                    }
     }
    }  
      
  return(0);
  }


void OnChartEvent(const int id,         // Event identifier  
                  const long& lparam,   // Event parameter of long type
                  const double& dparam, // Event parameter of double type
                  const string& sparam) // Event parameter of string type
  {
  
   if(!Freeze_DSWS)
    {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
//---  
  
    if(sparam=="Wick0")
     {
      ObjectDelete("Target_Zone_DSWS");
      ObjectDelete("Entry_Zone_DSWS");  
      ObjectDelete("Reversal_Zone_DSWS");
      ObjectDelete("Pot_Profit_Label_DSWS");
      ObjectDelete("PIVOT_DSWS");
      ObjectDelete("S1_DSWS");  
      ObjectDelete("S2_DSWS");
      ObjectDelete("S3_DSWS"); 
      ObjectDelete("S4_DSWS");           
      ObjectDelete("R1_DSWS");
      ObjectDelete("R2_DSWS");  
      ObjectDelete("R3_DSWS");
      ObjectDelete("R4_DSWS");      
      ObjectDelete("Close_Line_DSWS");
      ObjectDelete("PrevClose_Line_DSWS");
     }
     
      ObjectDelete("Target_Zone_DSWS");
      ObjectDelete("Entry_Zone_DSWS");  
      ObjectDelete("Reversal_Zone_DSWS");
      ObjectDelete("Pot_Profit_Label_DSWS");
      ObjectDelete("PIVOT_DSWS");
      ObjectDelete("S1_DSWS");  
      ObjectDelete("S2_DSWS");
      ObjectDelete("S3_DSWS"); 
      ObjectDelete("S4_DSWS");           
      ObjectDelete("R1_DSWS");
      ObjectDelete("R2_DSWS");  
      ObjectDelete("R3_DSWS"); 
      ObjectDelete("R4_DSWS");            
      ObjectDelete("Close_Line_DSWS");
      ObjectDelete("PrevClose_Line_DSWS");  

  t1=ObjectGetInteger(0,sparam,OBJPROP_TIME1);
  Shift=iBarShift(NULL,Master_Tf,t1,true);
  po=iOpen(NULL,Master_Tf,Shift);
  pc=iClose(NULL,Master_Tf,Shift);
  ph=iHigh(NULL,Master_Tf,Shift);
  pl=iLow(NULL,Master_Tf,Shift);

  t2=Time[0]+Period()*60*6; // t1+(Master_Timeframe*2)*60;+31536000
  
      double PIVOT=(ph+pl+pc)/3;
  if(PIVOT_Fib50_Mode) {
         PIVOT=(po+pc)/2;
    }      
      double R1=(2*PIVOT)-pl;      
      double S1=(2*PIVOT)-ph;      
      double R2=(PIVOT-S1)+R1;
      double S2=PIVOT-(R1-S1);
      double R3=(PIVOT-S2)+R2;
      double S3=PIVOT-(R2-S2);   
      double R4=R3+(R3-R2)+0.5*(R3-R2);
      double S4=S3-(S2-S3)-0.5*(S2-S3);  
      
       if(!Hide_Pivot)
        { 
      ObjectCreate("PIVOT_DSWS", OBJ_TREND, 0, Time[0]-31536000, PIVOT, t2, PIVOT );
      ObjectSet("PIVOT_DSWS", OBJPROP_COLOR, Pivot_Color);
      ObjectSet("PIVOT_DSWS", OBJPROP_STYLE, 2);
      ObjectSet("PIVOT_DSWS", OBJPROP_WIDTH, 0);
      ObjectSet("PIVOT_DSWS", OBJPROP_RAY, false);
      ObjectSet("PIVOT_DSWS", OBJPROP_BACK, true);         
        }  
         
       if(!Hide_Sup_Res_Lines)
        { 
       if(!Hide_Pivot)
        {
         HLINE("S1_DSWS",S1,Time[0]-31536000,t2,Sup_Res_Bear_Color);

         if(po>pc)
          {
          ObjectSet("S1_DSWS",OBJPROP_PRICE1,iClose(NULL,Master_Tf,Shift));
          ObjectSet("S1_DSWS",OBJPROP_PRICE2,iClose(NULL,Master_Tf,Shift));
          }
         if(po<pc)
          {
          ObjectSet("S1_DSWS",OBJPROP_PRICE1,iOpen(NULL,Master_Tf,Shift));
          ObjectSet("S1_DSWS",OBJPROP_PRICE2,iOpen(NULL,Master_Tf,Shift));
          }
          ObjectSet("S1_DSWS",OBJPROP_WIDTH,2);
        }          
         HLINE("S2_DSWS",S2,Time[0]-31536000,t2,Sup_Res_Bear_Color);
         HLINE("S3_DSWS",S3,Time[0]-31536000,t2,Sup_Res_Bull_Color);
         HLINE("S4_DSWS",S4,Time[0]-31536000,t2,Pivot_Color);  
       if(!Hide_Pivot)
        {
         HLINE("R1_DSWS",R1,Time[0]-31536000,t2,Sup_Res_Bull_Color);
         if(po>pc)
          {
          ObjectSet("R1_DSWS",OBJPROP_PRICE1,iOpen(NULL,Master_Tf,Shift));
          ObjectSet("R1_DSWS",OBJPROP_PRICE2,iOpen(NULL,Master_Tf,Shift));
          }
         if(po<pc)
          {
          ObjectSet("R1_DSWS",OBJPROP_PRICE1,iClose(NULL,Master_Tf,Shift));
          ObjectSet("R1_DSWS",OBJPROP_PRICE2,iClose(NULL,Master_Tf,Shift));
          }
          ObjectSet("R1_DSWS",OBJPROP_WIDTH,2);
         }
         HLINE("R2_DSWS",R2,Time[0]-31536000,t2,Sup_Res_Bull_Color);
         HLINE("R3_DSWS",R3,Time[0]-31536000,t2,Sup_Res_Bear_Color);
         HLINE("R4_DSWS",R4,Time[0]-31536000,t2,Pivot_Color);         
        }
               
 if(!Hide_Zones)
  { 
  ObjectCreate("Target_Zone_DSWS",OBJ_RECTANGLE,0,0,0);
  ObjectSet("Target_Zone_DSWS",OBJPROP_BACK,true);  

  
  ObjectCreate("Entry_Zone_DSWS",OBJ_RECTANGLE,0,0,0);  
  ObjectSet("Entry_Zone_DSWS",OBJPROP_BACK,true);  
 
     
  ObjectCreate("Reversal_Zone_DSWS",OBJ_RECTANGLE,0,0,0);  
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_BACK,true);  
 
  }
  //   ObjectCreate("Pot_Profit_Label_DSWS",OBJ_TEXT,0,0,0);
  //   ObjectSet("Pot_Profit_Label_DSWS",OBJPROP_TIME1,t1);     
  //   ObjectSet("Pot_Profit_Label_DSWS",OBJPROP_BACK,false);  
  //   ObjectSet("Pot_Profit_Label_DSWS",OBJPROP_SELECTABLE,false); 

  //   ObjectCreate("SW_Open_Line",OBJ_TREND,0,0,0);
  //   ObjectSet("SW_Open_Line",OBJPROP_BACK,false); 
  //   ObjectSet("SW_Open_Line",OBJPROP_RAY,false); 
  //   ObjectSet("SW_Open_Line",OBJPROP_WIDTH,2);    
  //   ObjectSet("SW_Open_Line",OBJPROP_STYLE,0);       
  //   ObjectSet("SW_Open_Line",OBJPROP_SELECTABLE,true); 
  
  if(po<pc)
   {
   
       if(!Hide_Pivot)
        {   
   ObjectDelete("PIVOT_DSWS");   
 
      ObjectCreate("PIVOT_DSWS", OBJ_TREND, 0, Time[0]-31536000, (R2+S2)/2, t2, (R2+S2)/2 );
      ObjectSet("PIVOT_DSWS", OBJPROP_COLOR, Pivot_Color);
      ObjectSet("PIVOT_DSWS", OBJPROP_STYLE, 0);
      ObjectSet("PIVOT_DSWS", OBJPROP_WIDTH, 1);
      ObjectSet("PIVOT_DSWS", OBJPROP_RAY, false);
      ObjectSet("PIVOT_DSWS", OBJPROP_BACK, true);   
       }  
  //0.236; 0.382; 0.618; 0.786; 0.841; 1.000; 1.272; 1.628//
  p382=ph; //-(ph-pl)*0.236;
  p618=ph-(ph-pl)*0.618;
  if(PIVOT_Fib50_Mode) {
         p618=pl;
    }   
  pt=ph+(ph-pl)*0.841*4;
  ptrev=pl-(ph-pl)*0.841*4;  
  Trend_Color=Bull_Trend_Color;
  Reversal_Color=Bear_Trend_Color; 
  Entry_Zone_Color=Entry_Zone_Buy_Color;

              if(PIVOT<=(p618+p382)/2) Entry_Zone_Color=Entry_Zone_Sell_Color; 
              if(PIVOT>(p618+p382)/2) Entry_Zone_Color=Entry_Zone_Buy_Color;  
              if(HL_Mode) ptrev = pl;
 if(!Hide_Zones)
  {  
  ObjectSet("Target_Zone_DSWS",OBJPROP_PRICE1,R2); 
  ObjectSet("Target_Zone_DSWS",OBJPROP_PRICE2,pt);  
     
  ObjectSet("Entry_Zone_DSWS",OBJPROP_PRICE1,R2); 
  ObjectSet("Entry_Zone_DSWS",OBJPROP_PRICE2,S2);  
 
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_PRICE1,S2); 
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_PRICE2,ptrev);  
  }
  
  //   ObjectSet("Pot_Profit_Label_DSWS",OBJPROP_PRICE1,pt);   
  //   ObjectSetText("Pot_Profit_Label_DSWS","Buy Target="+DoubleToStr((pt-p382)/Point,1)+" Pts",9,"Tahoma",Info_Color);   
  
   //  ObjectSet("SW_Open_Line",OBJPROP_PRICE1,iOpen(NULL,0,Shift+1)); 
   //  ObjectSet("SW_Open_Line",OBJPROP_PRICE2,iOpen(NULL,0,Shift+1)); 
   //  ObjectSet("SW_Open_Line",OBJPROP_COLOR,Entry_Zone_Sell_Color);   
   }
  if(po>pc)
   {
   
       if(!Hide_Pivot)
        {    
   ObjectDelete("PIVOT_DSWS");   
      ObjectCreate("PIVOT_DSWS", OBJ_TREND, 0, Time[0]-31536000, (R2+S2)/2, t2, (R2+S2)/2 );
      ObjectSet("PIVOT_DSWS", OBJPROP_COLOR, Pivot_Color);
      ObjectSet("PIVOT_DSWS", OBJPROP_STYLE, 0);
      ObjectSet("PIVOT_DSWS", OBJPROP_WIDTH, 1);
      ObjectSet("PIVOT_DSWS", OBJPROP_RAY, false);
      ObjectSet("PIVOT_DSWS", OBJPROP_BACK, true);      
        }
   
  p382=pl; //+(ph-pl)*0.236;
  p618=pl+(ph-pl)*0.618;
  if(PIVOT_Fib50_Mode) {
         p618=ph;
    }  
  pt=pl-(ph-pl)*0.841*4; 
  ptrev=ph+(ph-pl)*0.841*4;   
  Trend_Color=Bear_Trend_Color;
  Reversal_Color=Bull_Trend_Color;
  Entry_Zone_Color=Entry_Zone_Sell_Color;  
              if(PIVOT<=(p618+p382)/2) Entry_Zone_Color=Entry_Zone_Sell_Color; 
              if(PIVOT>(p618+p382)/2) Entry_Zone_Color=Entry_Zone_Buy_Color;
              if(HL_Mode) ptrev = ph;                
 if(!Hide_Zones)
  {   
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_PRICE1,ptrev); 
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_PRICE2,R2);
  
  //   ObjectSet("Pot_Profit_Label_DSWS",OBJPROP_PRICE1,pt);    
  //   ObjectSetText("Pot_Profit_Label_DSWS","Sell Target="+DoubleToStr((p382-pt)/Point,1)+" Pts",9,"Tahoma",Info_Color);  
   
  ObjectSet("Entry_Zone_DSWS",OBJPROP_PRICE1,R2); 
  ObjectSet("Entry_Zone_DSWS",OBJPROP_PRICE2,S2);    
 
  ObjectSet("Target_Zone_DSWS",OBJPROP_PRICE1,S2); 
  ObjectSet("Target_Zone_DSWS",OBJPROP_PRICE2,pt);
  }
  //   ObjectSet("SW_Open_Line",OBJPROP_PRICE1,iOpen(NULL,0,Shift+1)); 
  //   ObjectSet("SW_Open_Line",OBJPROP_PRICE2,iOpen(NULL,0,Shift+1)); 
  //   ObjectSet("SW_Open_Line",OBJPROP_COLOR,Entry_Zone_Buy_Color);    
   }
   
   
 if(!Hide_Zones)
  { 
  ObjectSet("Target_Zone_DSWS",OBJPROP_COLOR,Trend_Color); 
  ObjectSet("Target_Zone_DSWS",OBJPROP_TIME1,t1+Period()*60);
  ObjectSet("Target_Zone_DSWS",OBJPROP_TIME2,t2);  
   
  ObjectSet("Entry_Zone_DSWS",OBJPROP_COLOR,Entry_Zone_Color);
  ObjectSet("Entry_Zone_DSWS",OBJPROP_TIME1,t1+Period()*60);
  ObjectSet("Entry_Zone_DSWS",OBJPROP_TIME2,t2);
     
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_COLOR,Reversal_Color);
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_TIME1,t1+Period()*60);
  ObjectSet("Reversal_Zone_DSWS",OBJPROP_TIME2,t2);  
  }
  //   ObjectSet("SW_Open_Line",OBJPROP_TIME1,t1-Period()*60);
  //   ObjectSet("SW_Open_Line",OBJPROP_TIME2,t2);  

 
 if(Show_Close_Lines)
  {       
  if(pc>po){ 
    CL_Color = Close_Line_Color;
    }  
  if(pc<po){ 
    CL_Color = Close_Line_Color;
    }          
  ObjectCreate("Close_Line_DSWS",OBJ_TREND,0,0,0);
  ObjectSet("Close_Line_DSWS",OBJPROP_BACK,false); 
  ObjectSet("Close_Line_DSWS",OBJPROP_RAY,false); 
  ObjectSet("Close_Line_DSWS",OBJPROP_WIDTH,2);    
  ObjectSet("Close_Line_DSWS",OBJPROP_STYLE,0);       

  ObjectSet("Close_Line_DSWS",OBJPROP_PRICE1,pc); 
  ObjectSet("Close_Line_DSWS",OBJPROP_PRICE2,pc);            
  ObjectSet("Close_Line_DSWS",OBJPROP_TIME1,t1);
  ObjectSet("Close_Line_DSWS",OBJPROP_TIME2,t2); 
  ObjectSet("Close_Line_DSWS",OBJPROP_COLOR,CL_Color);
     
if(PTECZ_Mode)
 {  
  ObjectCreate("PrevClose_Line_DSWS",OBJ_TREND,0,0,0);
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_BACK,false); 
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_RAY,false); 
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_WIDTH,2);    
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_STYLE,0);       

  ObjectSet("PrevClose_Line_DSWS",OBJPROP_PRICE1,iClose(NULL,Master_Tf,Shift+1)); 
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_PRICE2,iClose(NULL,Master_Tf,Shift+1));            
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_TIME1,t1);
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_TIME2,t2); 
  ObjectSet("PrevClose_Line_DSWS",OBJPROP_COLOR,CL_Color); 
  }
  }      
//---
  }
  }
  }
//+------------------------------------------------------------------+
void HLINE(string name,double price,datetime timeBegin,datetime timeEnd,color paint,bool ray=false) {
      ObjectCreate(name, OBJ_TREND, 0, timeBegin, price, timeEnd, price );
      ObjectSet(name, OBJPROP_COLOR, paint);
      ObjectSet(name, OBJPROP_STYLE, 1);
      ObjectSet(name, OBJPROP_WIDTH, 0);
      ObjectSet(name, OBJPROP_RAY, false);
      ObjectSet(name, OBJPROP_BACK, true);

      }
//+------------------------------------------------------------------+

bool IsNewBar()
{ 
  static datetime Trend_Candle_prevTime1 = -1;
  
  if(Trend_Candle_prevTime1 != Time[6])
  { 
   Trend_Candle_prevTime1 = Time[6]; 
       
   return(true);  
  } 

  return(false); 
}
//+------------------------------------------------------------------+